proc timeHistoryAnalyze {npts dt tol} {
# 输入参数：
# npts: 地震文件中数据点的个数
# dt: 地震文件中数据点之间的时间间隔
# tol: 最小允许的时间步长

# 当前分析时间
set current 0.0
# 是否收敛 收敛时ok=0
set ok 0
# 增加的步数，用于屏幕输出
set incr 0
# 在指定时间范围内循环，如果不收敛则退出
while {$ok == 0 && $current < [expr $npts * $dt] } {
# 设置初始时间间隔与地震记录时间间隔相同
set interval $dt
# 以$interval时间间隔分析一步
set ok [analyze 1 $interval]
# 计数器加1
set incr [expr $incr + 1]
# 如果刚才的分析步不收敛，减小步长，但不小于定义的最小步长
while {$ok != 0 && $interval>1.0e-7} {
	# 步长减半
	set interval [expr $interval/2]
	puts "Fail to convenge at time $current, set a new step length = $interval"
	# 重新分析
	set ok [analyze 1 $interval]
	# 计数器加1
	set incr [expr $incr + 1]
}
# 当前时间增加
set current [expr $current + $interval]
# 每10步输入一次信息
if {[expr $incr % 10] == 0} {
	puts "analyzing at time $current"
}
}
puts "analyze done with code $ok!"
}